(require 'quail)

(defun accentuate-region (start end)
  "Replace the region by using it as keys using the current input method"
  (interactive "r")
  (save-mark-and-excursion
    (when (< (mark) (point)) (exchange-point-and-mark))
    (let ((tend (1+ (point))) def)
      (while (<= tend (mark))
        (let* ((candx (buffer-substring (point) tend))
               (mapx (quail-lookup-key candx))
               (defx (and mapx (quail-map-definition mapx))))
          (if (null mapx)
              (progn
                (if def
                    (let* ((end (1- tend)) (len (- end (point))))
                      (delete-region (point) end)
                      (insert (quail-get-current-str len def))
                      (setq tend (point)))
                  (forward-char))
                (setq def nil))
            (if (and defx (null (cdr mapx)))
                (progn
                  (delete-region (point) tend)
                  (insert (quail-get-current-str (length candx) defx))
                  (setq def nil tend (point)))
              (setq def defx)))
          (cl-incf tend)))
      (when def
        (let ((len (- (mark) (point))))
          (delete-region (point) (mark))
          (insert (quail-get-current-str (- (mark) (point)) def)))))))


(defun unaccentuate-region (start end)
  "Perform the reverse operation of typing in the current input method.
Replace the region with the keys used to type that text using the
current input method"
  (interactive "r")
  (save-mark-and-excursion
    (when (< (mark) (point)) (exchange-point-and-mark))
    (while (< (point) (mark))
      (condition-case nil
          (let ((keys (quail-find-key (following-char))))
            (if (consp keys)
                (progn (delete-char 1) (insert (car keys)))
              (forward-char)))))))
